/*@ predicate is_id(int *a, integer k) =
  @  \forall integer i; 0 <= i < k ==> a[i] == i;
  @ predicate is_le(int *a, integer b, integer c, integer p, integer n) =
  @  \forall integer i; b <= i < c ==> 0 <= a[i] <= n-1-(p-1-i);
  @ predicate is_lt(int *a, integer b, integer c, integer n) =
  @  \forall integer i; b <= i < c ==> 0 <= a[i] < n;
  @ predicate is_lt_next(int *a, integer b, integer c) =
  @  \forall integer i; b <= i < c ==> a[i] < a[i+1];
  @ predicate is_comb(int *a, integer p, integer n) =
  @  is_lt(a,0,p,n) && is_lt_next(a,0,p-1); */

/*@ lemma trans_le:
  @   \forall int *a;
  @   \forall integer b; \forall integer c; \forall integer d;
  @   \forall integer p; \forall integer n;
  @    (is_le(a,b,c,p,n) && is_le(a,c,d,p,n)) ==> is_le(a,b,d,p,n); */

/*@ lemma trans_lt:
  @   \forall int *a;
  @   \forall integer b; \forall integer c; \forall integer d;
  @   \forall integer n;
  @    (is_lt(a,b,c,n) && is_lt(a,c,d,n)) ==> is_lt(a,b,d,n); */

/*@ lemma trans_lt_next:
  @   \forall int *a;
  @   \forall integer b; \forall integer c; \forall integer d;
  @    (is_lt_next(a,b,c) && is_lt_next(a,c,d)) ==> is_lt_next(a,b,d); */

// Function declarations

/*@ requires 1 < p <= n;
  @ requires \valid(c+(0..p-1));
  @ requires 1 <= rev <= p-1;
  @ requires is_comb(c,p,n);
  @ requires is_le(c,0,p,p,n);
  @ assigns c[rev..p-1];
  @ ensures is_comb(c,p,n);
  @ ensures is_le(c,0,p,p,n); */
void fillEnd(int c[], int rev, int p, int n);

/*@ requires 1 < p <= n;
  @ requires \valid(c+(0..p-1));
  @ requires is_comb(c,p,n);
  @ requires is_le(c,0,p,p,n);
  @ assigns c[0..p-1];
  @ ensures is_comb(c,p,n);
  @ ensures is_le(c,0,p,p,n); */
int nextComb(int c[], int p, int n);

/*@ requires 1 <= p <= n;
  @ requires \valid(c+(0..p-1));
  @ assigns c[0..p-1];
  @ ensures is_id(c,p);
  @ ensures is_comb(c,p,n); */
void firstComb(int c[], int p, int n);

