/*@ predicate is_inc(int *a, integer n) =
  @  \forall integer i; 1 <= i < n ==> a[i] > a[i-1];
  @ predicate is_comb(int *a, integer p, integer n) =
  @  is_fct(a,p,n) && is_inc(a,p);
  @*/

// Function declarations

/*@ @ requires p > 0 && n >= p && \valid(a+(0..p-1));
  @ assigns a[0..p-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_comb(a,p,n); */
int firstComb(int a[], int p, int n);

/*@ requires p > 0 && n >= p && \valid(a+(0..p-1));
  @ requires is_comb(a,p,n);
  @ assigns a[0..p-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_comb(a,p,n); */
int nextComb(int a[], int p, int n);
