/*@ predicate is_ff(int *a, integer n) =
  @  \forall integer i; 0 <= i < n ==> a[i] != i;
  @ predicate is_derang(int *a, integer n) = is_perm(a,n) && is_ff(a,n); */
  
// Function declarations

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_derang(a,n); */
int firstDerang(int a[], int n);

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_derang(a,n);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_derang(a,n); */
int nextDerang(int a[], int n);
