/* Generation algorithm for endofunctions on [0..n-1].
 * Here, by specialization of functions from [0..n-1] to [0..k-1].
 * All is proved with frama-c Neon and alt-Ergo 0.95.1. */

#include "../fct/fct.h"

/*@ predicate is_endofct(int *a, integer n) = is_fct(a,n,n); */
  
/*@ requires n > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures is_endofct(a,n); */
int firstEndofct(int a[], int n) {
 return firstFct(a,n,n);
}

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_endofct(a,n);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures is_endofct(a,n); */
int nextEndofct(int a[], int n) {
 return nextFct(a,n,n);
}
