/*@ predicate is_le_pred(int *a, integer n) =
  @  (\forall integer i; 1 <= i < n ==> a[i] <= a[i-1]+1); 
  @ predicate is_RGF(int *a, integer n) = is_endofct(a,n) && a[0] == 0
  @  && is_le_pred(a,n); */

// Function declarations

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_RGF(a,n); */
int firstRGF(int a[], int n);

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_RGF(a,n);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_RGF(a,n); */
int nextRGF(int a[], int n);
