/*@ predicate is_inv(int *a, integer n) = 
  @  \forall integer i; 0 <= i < n ==> a[a[i]] == i;
  @ predicate is_invol(int *a, integer n) = 
  @  is_perm(a,n) && is_inv(a,n); */

// Function declarations

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_invol(a,n); */
int firstInvol(int a[], int n);

/*@ requires n > 0 && \valid(a+(0..n-1));
  @ requires is_invol(a,n);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_invol(a,n); */
int nextInvol(int a[], int n);
