/* Validation of the generator in invol.c by counting. */

#include <stdio.h>
// Additional library for time counting
#include <time.h>

#include "invol.h"
#include "../../fcts/fcts.c"

#define MAX 16

int main(int argc,char *argv[]) {
 int c, n;
 int p[MAX]; 
 
  // Variables for time computation:
 clock_t lasttime, now, diff;
 
 if (argc != 2) {
  printf("Invalid number of arguments.\n");
  printf("Usage: invol [n]\n");
  printf("Generation of involutions of size n.\n");
  return(-1);
 }

 n = atoi(argv[argc-1]);
 if (n < 1) {
  printf("Invalid first argument: The minimal size should be 1 or more.\n");
  return(-1);
 }
 if (n > MAX) {
  printf("Invalid first argument: The minimal size should be structurally %d or less.\n",MAX);
  return(-1);
 }

 printf("Involutions of %d elements:\n",n);
 printf("\n");  

 firstInvol(p,n);   
 displayl(p,n);
 printf("\n");
  
 c = 1;      
 lasttime = clock(); 
  
 while(nextInvol(p,n) == 1) {
  displayl(p,n);
  printf("\n");
  c++;
 }
  printf("Number of involutions of %d elements generated: %d\n", n, c);
  if (c == count85(n)) {
   printf("Equal to the %d-th number of the sequence https://oeis.org/A000085.\n",n);
  } else {
   printf("Not equal to %d (%d-th number of the sequence https://oeis.org/A000085).\n",count85(n),n);
  }
  now = clock();
  diff = (now - lasttime) / (CLOCKS_PER_SEC / 1000);
  printf("Time (ms): %ld\n", (long) diff);
  printf("\n");

 return 0;
}
