/*@ predicate is_eq_im(int *a, integer n, integer j) =
  @  \exists integer i; 0 <= i < n ==> a[i] == j;
  @ predicate is_imEndo(int *a, integer n) =
  @  \forall integer j; 0 <= j <= n-1 ==> is_eq_im(a,n,j);
  @ predicate is_surjEndo(int *a, integer n) = 
     is_endofct(a,n) && is_imEndo(a,n); */

// Function declarations

/*@ requires k > 0 && n >= k && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_surj(a,n,k); */
int firstSurjEndo(int a[], int n);

/*@ requires k > 0 && n >= k && \valid(a+(0..n-1));
  @ requires is_surj(a,n,k);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_surj(a,n,k); */
int nextSurjEndo(int a[], int n);
