/*@ predicate is_X3(int *a, integer n, integer n1, integer n2) = a[n2] == n1;
  @ predicate is_eq_im_gen(int *a, integer n, integer n1, integer n2, integer k) = \exists integer i2; 0 <= i2 < n2 && is_X3(a,n,n1,i2);
  @ predicate is_eq_im(int *a, integer n, integer n1, integer k) = is_eq_im_gen(a,n,n1,n,k);
  @ predicate is_im_gen(int *a, integer n, integer n1, integer k) = \forall integer i1; 0 <= i1 < n1 ==> is_eq_im(a,n,i1,k);
  @ predicate is_im(int *a, integer n, integer k) = is_im_gen(a,n,n,k); 
  @ predicate is_surj(int *a, integer n, integer k) = is_fct(a,n,k) && is_im(a,n,k); */
     
// Function declarations

/*@ requires n >= k > 0 && \valid(a+(0..n-1));
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_surj(a,n,k); */
int firstSurj(int a[], int n, int k);

/*@ requires n >= k > 0 && \valid(a+(0..n-1));
  @ requires is_surj(a,n,k);
  @ assigns a[0..n-1];
  @ ensures \result == 0 || \result == 1;
  @ ensures \result == 1 ==> is_surj(a,n,k); */
int nextSurj(int a[], int n, int k);

